//
//  NetActivity.swift
//  Buscar Peliculas
//
//  Created by Santiago Pavón Gómez on 14/12/15.
//  Copyright © 2015 UPM. All rights reserved.
//

import UIKit

class NetActivity {
    
    private static var pred : dispatch_once_t = 0
    
    private static var instance : NetActivity?
    
    // Propiedad calculada que devuelve la unica instancia
    static var shared : NetActivity {
        
        dispatch_once(&pred) {
            instance = NetActivity()
        }
        
        return instance!
    }
    
    /**
    *  Contador usado para saber cuantas veces hemos ejecutado:
    *    UIApplication.sharedApplication().networkActivityIndicatorVisible = true
    *  Esta sentencia activa el indicador de actividad en la red.
    *  Mientras este contador sea mauor que cero no pararemos el indicador.
    */
    private var netActivityCredit = 0
    
    /**
     *  Activa el indicador de actividad de red.
     */
    func incrNetActivity() {
        ++netActivityCredit
        UIApplication.sharedApplication().networkActivityIndicatorVisible = true
    }
    
    /**
     *  Desactiva el indicador de actividad de red.
     */
    func decrNetActivity() {
        --netActivityCredit
        if netActivityCredit < 1 {
            UIApplication.sharedApplication().networkActivityIndicatorVisible = false
        }
    }
}
