//
//  StartViewController.swift
//  Buscar Peliculas
//
//  Created by Santiago Pavón Gómez on 14/12/15.
//  Copyright © 2015 UPM. All rights reserved.
//

import UIKit

class StartViewController: UIViewController {

    @IBOutlet weak var inputField: UITextField!
    
    @IBOutlet weak var buscarButton: UIButton!
    
    // URL Session para descargar datos
    var session: NSURLSession?
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        inputField.enabled = false
        buscarButton.enabled = false
    }
    
    override func viewDidAppear(animated: Bool) {
        super.viewDidAppear(animated)
        
        if checkToken() {
            
            inputField.enabled = true
            buscarButton.enabled = true
            
            inputField.becomeFirstResponder()
            
            let config = NSURLSessionConfiguration.defaultSessionConfiguration()
            session = NSURLSession(configuration: config)
        }
    
    }
    
    // Comprobar que hemos puesto el valor del token
    private func checkToken() -> Bool {
        if Constants.TOKEN == "" {
            let alert = UIAlertController(title: "Token", message: "Para utilizar esta aplicación debe obtener un token en la página http://api.myapifilms.com/token.do", preferredStyle: .Alert)
            
            alert.addAction(UIAlertAction(
                title: "Vale",
                style: UIAlertActionStyle.Default) {(_: UIAlertAction) -> Void in
                    self.dismissViewControllerAnimated(true, completion: nil)
                })
            
            presentViewController(alert, animated: true, completion: nil)
            
            return false
        }
        return true
    }

    
    @IBAction func search() {
        performSegueWithIdentifier("Show Film", sender: self)
    }

    // MARK: - Navigation

    override func prepareForSegue(segue: UIStoryboardSegue, sender: AnyObject?) {
        
        if segue.identifier == "Show Film" {
            if let ftvc = segue.destinationViewController as? FilmsTableViewController {
                
                ftvc.filmName = inputField.text
                ftvc.session = session!
            }
        }
    }

}
